Index: binaries/data/mods/public/simulation/ai/common-api-v3/entity.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/entity.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/entity.js	(Arbeitskopie)
@@ -1,5 +1,8 @@
-var EntityTemplate = Class({
+var API3 = function(m)
+{
 
+m.EntityTemplate = m.Class({
+
 	// techModifications should be the tech modifications of only one player.
 	// gamestates handle "GetTemplate" and should push the player's
 	// while entities should push the owner's
@@ -447,8 +450,8 @@
 
 
 
-var Entity = Class({
-	_super: EntityTemplate,
+m.Entity = m.Class({
+	_super: m.EntityTemplate,
 
 	_init: function(sharedAI, entity)
 	{
@@ -576,7 +579,7 @@
 		return this._entity.resourceCarrying; 
 	},
 
-	garrisoned: function() { return new EntityCollection(this._ai, this._entity.garrisoned); },
+	garrisoned: function() { return new m.EntityCollection(this._ai, this._entity.garrisoned); },
 	
 	canGarrisonInside: function() { return this._entity.garrisoned.length < this.garrisonMax(); },
 
@@ -584,32 +587,32 @@
 
 	move: function(x, z, queued) {
 		queued = queued || false;
-		Engine.PostCommand({"type": "walk", "entities": [this.id()], "x": x, "z": z, "queued": queued });
+		Engine.PostCommand(PlayerID,{"type": "walk", "entities": [this.id()], "x": x, "z": z, "queued": queued });
 		return this;
 	},
 	
 	attackMove: function(x, z, queued) {
 		queued = queued || false;
-		Engine.PostCommand({"type": "attack-walk", "entities": [this.id()], "x": x, "z": z, "queued": queued });
+		Engine.PostCommand(PlayerID,{"type": "attack-walk", "entities": [this.id()], "x": x, "z": z, "queued": queued });
 		return this;
 	},
 
 	// violent, aggressive, defensive, passive, standground
 	setStance: function(stance,queued){
-		Engine.PostCommand({"type": "stance", "entities": [this.id()], "name" : stance, "queued": queued });
+		Engine.PostCommand(PlayerID,{"type": "stance", "entities": [this.id()], "name" : stance, "queued": queued });
 		return this;
 	},
 
 	// TODO: replace this with the proper "STOP" command
 	stopMoving: function() {
 		if (this.position() !== undefined)
-			Engine.PostCommand({"type": "walk", "entities": [this.id()], "x": this.position()[0], "z": this.position()[1], "queued": false});
+			Engine.PostCommand(PlayerID,{"type": "walk", "entities": [this.id()], "x": this.position()[0], "z": this.position()[1], "queued": false});
 	},
 
 	unload: function(id) {
 		if (!this._template.GarrisonHolder)
 			return undefined;
-		Engine.PostCommand({"type": "unload", "garrisonHolder": this.id(), "entities": [id]});
+		Engine.PostCommand(PlayerID,{"type": "unload", "garrisonHolder": this.id(), "entities": [id]});
 		return this;
 	},
 
@@ -617,17 +620,17 @@
 	unloadAll: function() {
 		if (!this._template.GarrisonHolder)
 			return undefined;
-		Engine.PostCommand({"type": "unload-all-own", "garrisonHolders": [this.id()]});
+		Engine.PostCommand(PlayerID,{"type": "unload-all-own", "garrisonHolders": [this.id()]});
 		return this;
 	},
 
 	garrison: function(target) {
-		Engine.PostCommand({"type": "garrison", "entities": [this.id()], "target": target.id(),"queued": false});
+		Engine.PostCommand(PlayerID,{"type": "garrison", "entities": [this.id()], "target": target.id(),"queued": false});
 		return this;
 	},
 
 	attack: function(unitId) {
-		Engine.PostCommand({"type": "attack", "entities": [this.id()], "target": unitId, "queued": false});
+		Engine.PostCommand(PlayerID,{"type": "attack", "entities": [this.id()], "target": unitId, "queued": false});
 		return this;
 	},
 	
@@ -635,40 +638,40 @@
 	flee: function(unitToFleeFrom) {
 		if (this.position() !== undefined && unitToFleeFrom.position() !== undefined) {
 			var FleeDirection = [this.position()[0] - unitToFleeFrom.position()[0],this.position()[1] - unitToFleeFrom.position()[1]];
-			var dist = VectorDistance(unitToFleeFrom.position(), this.position() );
+			var dist = m.VectorDistance(unitToFleeFrom.position(), this.position() );
 			FleeDirection[0] = (FleeDirection[0]/dist) * 8;
 			FleeDirection[1] = (FleeDirection[1]/dist) * 8;
 			
-			Engine.PostCommand({"type": "walk", "entities": [this.id()], "x": this.position()[0] + FleeDirection[0]*5, "z": this.position()[1] + FleeDirection[1]*5, "queued": false});
+			Engine.PostCommand(PlayerID,{"type": "walk", "entities": [this.id()], "x": this.position()[0] + FleeDirection[0]*5, "z": this.position()[1] + FleeDirection[1]*5, "queued": false});
 		}
 		return this;
 	},
 
 	gather: function(target, queued) {
 		queued = queued || false;
-		Engine.PostCommand({"type": "gather", "entities": [this.id()], "target": target.id(), "queued": queued});
+		Engine.PostCommand(PlayerID,{"type": "gather", "entities": [this.id()], "target": target.id(), "queued": queued});
 		return this;
 	},
 
 	repair: function(target, queued) {
 		queued = queued || false;
-		Engine.PostCommand({"type": "repair", "entities": [this.id()], "target": target.id(), "autocontinue": false, "queued": queued});
+		Engine.PostCommand(PlayerID,{"type": "repair", "entities": [this.id()], "target": target.id(), "autocontinue": false, "queued": queued});
 		return this;
 	},
 	
 	returnResources: function(target, queued) {
 		queued = queued || false;
-		Engine.PostCommand({"type": "returnresource", "entities": [this.id()], "target": target.id(), "queued": queued});
+		Engine.PostCommand(PlayerID,{"type": "returnresource", "entities": [this.id()], "target": target.id(), "queued": queued});
 		return this;
 	},
 
 	destroy: function() {
-		Engine.PostCommand({"type": "delete-entities", "entities": [this.id()] });
+		Engine.PostCommand(PlayerID,{"type": "delete-entities", "entities": [this.id()] });
 		return this;
 	},
 	
 	barter: function(buyType, sellType, amount) {
-		Engine.PostCommand({"type": "barter", "sell" : sellType, "buy" : buyType, "amount" : amount });
+		Engine.PostCommand(PlayerID,{"type": "barter", "sell" : sellType, "buy" : buyType, "amount" : amount });
 		return this;
 	},
 	
@@ -686,7 +689,7 @@
 			return this;
 		}
 
-		Engine.PostCommand({
+		Engine.PostCommand(PlayerID,{
 			"type": "train",
 			"entities": [this.id()],
 			"template": type,
@@ -699,8 +702,7 @@
 	construct: function(template, x, z, angle, metadata) {
 		// TODO: verify this unit can construct this, just for internal
 		// sanity-checking and error reporting
-
-		Engine.PostCommand({
+		Engine.PostCommand(PlayerID,{
 			"type": "construct",
 			"entities": [this.id()],
 			"template": template,
@@ -716,12 +718,12 @@
 	},
 				   
 	 research: function(template) {
-		Engine.PostCommand({ "type": "research", "entity": this.id(), "template": template });
+		Engine.PostCommand(PlayerID,{ "type": "research", "entity": this.id(), "template": template });
 		return this;
 	},
 
 	stopProduction: function(id) {
-		Engine.PostCommand({ "type": "stop-production", "entity": this.id(), "id": id });
+		Engine.PostCommand(PlayerID,{ "type": "stop-production", "entity": this.id(), "id": id });
 		return this;
 	},
 	
@@ -732,9 +734,12 @@
 		for (var i in queue)
 		{
 			if (queue[i].progress < percentToStopAt)
-				Engine.PostCommand({ "type": "stop-production", "entity": this.id(), "id": queue[i].id });
+				Engine.PostCommand(PlayerID,{ "type": "stop-production", "entity": this.id(), "id": queue[i].id });
 		}
 		return this;
 	}
 });
 
+return m;
+
+}(API3);
Index: binaries/data/mods/public/simulation/ai/common-api-v3/terrain-analysis.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/terrain-analysis.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/terrain-analysis.js	(Arbeitskopie)
@@ -1,3 +1,6 @@
+var API3 = function(m)
+{
+
 /*
  * TerrainAnalysis, inheriting from the Map Component.
  * 
@@ -12,13 +15,13 @@
  * But truly separating optimizes.
  */
 
-function TerrainAnalysis() {
+m.TerrainAnalysis = function() {
 	this.cellSize = 4;
 }
 
-copyPrototype(TerrainAnalysis, Map);
+m.copyPrototype(m.TerrainAnalysis, m.Map);
 
-TerrainAnalysis.prototype.init = function(sharedScript,rawState) {
+m.TerrainAnalysis.prototype.init = function(sharedScript,rawState) {
 	var self = this;
 
 	var passabilityMap = rawState.passabilityMap;
@@ -108,7 +111,7 @@
 };
 
 // Returns the (approximately) closest point which is passable by searching in a spiral pattern 
-TerrainAnalysis.prototype.findClosestPassablePoint = function(startPoint, onLand, limitDistance, quickscope){
+m.TerrainAnalysis.prototype.findClosestPassablePoint = function(startPoint, onLand, limitDistance, quickscope){
 	var w = this.width;
 	var p = startPoint;
 	var direction = 1;
@@ -150,7 +153,7 @@
 
 // Returns an estimate of a tile accessibility. It checks neighboring cells over two levels.
 // returns a count. It's not integer. About 2 should be fairly accessible already.
-TerrainAnalysis.prototype.countConnected = function(startIndex, byLand){
+m.TerrainAnalysis.prototype.countConnected = function(startIndex, byLand){
 	var count = 0.0;
 	
 	var w = this.width;
@@ -181,7 +184,7 @@
 };
 
 // TODO: for now this resets to 255.
-TerrainAnalysis.prototype.updateMapWithEvents = function(sharedAI) {
+m.TerrainAnalysis.prototype.updateMapWithEvents = function(sharedAI) {
 	var self = this;
 	
 	var events = sharedAI.events;
@@ -243,13 +246,13 @@
  * so this can use the land regions already.
 
  */
-function Accessibility() {
+m.Accessibility = function() {
 	
 }
 
-copyPrototype(Accessibility, TerrainAnalysis);
+m.copyPrototype(m.Accessibility, m.TerrainAnalysis);
 
-Accessibility.prototype.init = function(rawState, terrainAnalyser){
+m.Accessibility.prototype.init = function(rawState, terrainAnalyser){
 	var self = this;
 	
 	this.Map(rawState, terrainAnalyser.map);
@@ -322,7 +325,7 @@
 	//Engine.DumpImage("NavalPassMap.png", this.navalPassMap, this.width, this.height, 255);
 }
 
-Accessibility.prototype.getAccessValue = function(position, onWater) {
+m.Accessibility.prototype.getAccessValue = function(position, onWater) {
 	var gamePos = this.gamePosToMapPos(position);
 	if (onWater === true)
 		return this.navalPassMap[gamePos[0] + this.width*gamePos[1]];
@@ -343,7 +346,7 @@
 
 // Returns true if a point is deemed currently accessible (is not blocked by surrounding trees...)
 // NB: accessible means that you can reach it from one side, not necessariliy that you can go ON it.
-Accessibility.prototype.isAccessible = function(gameState, position, onLand){
+m.Accessibility.prototype.isAccessible = function(gameState, position, onLand){
 	var gamePos = this.gamePosToMapPos(position);
 	
 	// quick check
@@ -356,7 +359,7 @@
 // Return true if you can go from a point to a point without switching means of transport
 // Hardcore means is also checks for isAccessible at the end (it checks for either water or land though, beware).
 // This is a blind check and not a pathfinder: for all it knows there is a huge block of trees in the middle.
-Accessibility.prototype.pathAvailable = function(gameState, start, end, onWater, hardcore){
+m.Accessibility.prototype.pathAvailable = function(gameState, start, end, onWater, hardcore){
 	var pstart = this.gamePosToMapPos(start);
 	var istart = pstart[0] + pstart[1]*this.width;
 	var pend = this.gamePosToMapPos(end);
@@ -382,7 +385,7 @@
 	return false;
 };
 
-Accessibility.prototype.getTrajectTo = function(start, end, noBound) {
+m.Accessibility.prototype.getTrajectTo = function(start, end, noBound) {
 	var pstart = this.gamePosToMapPos(start);
 	var istart = pstart[0] + pstart[1]*this.width;
 	var pend = this.gamePosToMapPos(end);
@@ -413,7 +416,7 @@
 // assumes a land unit unless start point is over deep water.
 // if the path is more complicated than "land->sea->land" (or "sea->land->sea"), it will run A* to try and figure it out
 // Thus it can handle arbitrarily complicated paths (theoretically).
-Accessibility.prototype.getTrajectToIndex = function(istart, iend, noBound){
+m.Accessibility.prototype.getTrajectToIndex = function(istart, iend, noBound){
 	var startRegion = istart;
 	var currentRegion = istart;
 	
@@ -530,7 +533,7 @@
 	return path;
 };
 
-Accessibility.prototype.getRegionSize = function(position, onWater){
+m.Accessibility.prototype.getRegionSize = function(position, onWater){
 	var pos = this.gamePosToMapPos(position);
 	var index = pos[0] + pos[1]*this.width;
 	var ID = (onWater === true) ? this.navalPassMap[index] : this.landPassMap[index];
@@ -539,7 +542,7 @@
 	return this.regionSize[ID];
 };
 
-Accessibility.prototype.getRegionSizei = function(index, onWater) {
+m.Accessibility.prototype.getRegionSizei = function(index, onWater) {
 	if (this.regionSize[this.landPassMap[index]] === undefined && (!onWater || this.regionSize[this.navalPassMap[index]] === undefined))
 		return 0;
 	if (onWater && this.regionSize[this.navalPassMap[index]] > this.regionSize[this.landPassMap[index]])
@@ -549,7 +552,7 @@
 
 // Implementation of a fast flood fill. Reasonably good performances for JS.
 // TODO: take big zones of impassable trees into account?
-Accessibility.prototype.floodFill = function(startIndex, value, onWater)
+m.Accessibility.prototype.floodFill = function(startIndex, value, onWater)
 {
 	this.s = startIndex;
 	if ((!onWater && this.landPassMap[this.s] !== 0) || (onWater && this.navalPassMap[this.s] !== 0) ) {
@@ -668,16 +671,16 @@
 }
 
 // creates a map of resource density
-SharedScript.prototype.createResourceMaps = function(sharedScript) {
+m.SharedScript.prototype.createResourceMaps = function(sharedScript) {
 	
 	for (var resource in this.decreaseFactor){
 		// if there is no resourceMap create one with an influence for everything with that resource
 		if (! this.resourceMaps[resource]){
 			// We're creting them 8-bit. Things could go above 255 if there are really tons of resources
 			// But at that point the precision is not really important anyway. And it saves memory.
-			this.resourceMaps[resource] = new Map(sharedScript, new Uint8Array(sharedScript.passabilityMap.data.length));
+			this.resourceMaps[resource] = new m.Map(sharedScript, new Uint8Array(sharedScript.passabilityMap.data.length));
 			this.resourceMaps[resource].setMaxVal(255);
-			this.CCResourceMaps[resource] = new Map(sharedScript, new Uint8Array(sharedScript.passabilityMap.data.length));
+			this.CCResourceMaps[resource] = new m.Map(sharedScript, new Uint8Array(sharedScript.passabilityMap.data.length));
 			this.CCResourceMaps[resource].setMaxVal(255);
 		}
 	}
@@ -711,16 +714,16 @@
 // creates and maintains a map of unused resource density
 // this also takes dropsites into account.
 // resources that are "part" of a dropsite are not counted.
-SharedScript.prototype.updateResourceMaps = function(sharedScript, events) {
+m.SharedScript.prototype.updateResourceMaps = function(sharedScript, events) {
 	
 	for (var resource in this.decreaseFactor){
 		// if there is no resourceMap create one with an influence for everything with that resource
 		if (! this.resourceMaps[resource]){
 			// We're creting them 8-bit. Things could go above 255 if there are really tons of resources
 			// But at that point the precision is not really important anyway. And it saves memory.
-			this.resourceMaps[resource] = new Map(sharedScript, new Uint8Array(sharedScript.passabilityMap.data.length));
+			this.resourceMaps[resource] = new m.Map(sharedScript, new Uint8Array(sharedScript.passabilityMap.data.length));
 			this.resourceMaps[resource].setMaxVal(255);
-			this.CCResourceMaps[resource] = new Map(sharedScript, new Uint8Array(sharedScript.passabilityMap.data.length));
+			this.CCResourceMaps[resource] = new m.Map(sharedScript, new Uint8Array(sharedScript.passabilityMap.data.length));
 			this.CCResourceMaps[resource].setMaxVal(255);
 		}
 	}
@@ -780,3 +783,7 @@
 		}
 	}
 };
+
+return m;
+
+}(API3);
Index: binaries/data/mods/public/simulation/ai/common-api-v3/entitycollection.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/entitycollection.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/entitycollection.js	(Arbeitskopie)
@@ -1,5 +1,8 @@
-function EntityCollection(sharedAI, entities, filters)
+var API3 = function(m)
 {
+
+m.EntityCollection = function(sharedAI, entities, filters)
+{
 	this._ai = sharedAI;
 	this._entities = entities || {};
 	this._filters = filters || [];
@@ -22,22 +25,22 @@
 		}
 	});
 	this.frozen = false;
-}
+};
 
 // If an entitycollection is frozen, it will never automatically add a unit.
 // But can remove one.
 // this makes it easy to create entity collection that will auto-remove dead units
 // but never add new ones.
-EntityCollection.prototype.freeze = function()
+m.EntityCollection.prototype.freeze = function()
 {
 	this.frozen = true;
 };
-EntityCollection.prototype.defreeze = function()
+m.EntityCollection.prototype.defreeze = function()
 {
 	this.frozen = false;
 };
 
-EntityCollection.prototype.allowQuickIter = function()
+m.EntityCollection.prototype.allowQuickIter = function()
 {
 	this._quickIter = true;
 	this._entitiesArray = [];
@@ -45,7 +48,7 @@
 		this._entitiesArray.push(ent);
 };
 
-EntityCollection.prototype.toIdArray = function()
+m.EntityCollection.prototype.toIdArray = function()
 {
 	var ret = [];
 	for (var id in this._entities)
@@ -53,7 +56,7 @@
 	return ret;
 };
 
-EntityCollection.prototype.toEntityArray = function()
+m.EntityCollection.prototype.toEntityArray = function()
 {
 	if (this._quickIter === true)
 		return this._entitiesArray;
@@ -63,7 +66,7 @@
 	return ret;
 };
 
-EntityCollection.prototype.toString = function()
+m.EntityCollection.prototype.toString = function()
 {
 	return "[EntityCollection " + this.toEntityArray().join(" ") + "]";
 };
@@ -71,7 +74,7 @@
 /**
  * Returns the (at most) n entities nearest to targetPos.
  */
-EntityCollection.prototype.filterNearest = function(targetPos, n)
+m.EntityCollection.prototype.filterNearest = function(targetPos, n)
 {
 	// Compute the distance of each entity
 	var data = []; // [id, ent, distance]
@@ -82,14 +85,14 @@
 		{
 			var ent = this._entitiesArray[i];
 			if (ent.position() !== -1)
-				data.push([ent.id(), ent, SquareVectorDistance(targetPos, ent.position())]);
+				data.push([ent.id(), ent, m.SquareVectorDistance(targetPos, ent.position())]);
 		}
 	} else {
 		for (var id in this._entities)
 		{
 			var ent = this._entities[id];
 			if (ent.position() !== -1)
-				data.push([id, ent, SquareVectorDistance(targetPos, ent.position())]);
+				data.push([id, ent, m.SquareVectorDistance(targetPos, ent.position())]);
 		}
 	}
 
@@ -102,10 +105,10 @@
 	for (var i = 0; i < length; ++i)
 		ret[data[i][0]] = data[i][1];
 
-	return new EntityCollection(this._ai, ret);
+	return new m.EntityCollection(this._ai, ret);
 };
 
-EntityCollection.prototype.filter = function(filter, thisp)
+m.EntityCollection.prototype.filter = function(filter, thisp)
 {
 	if (typeof(filter) == "function")
 		filter = {"func": filter, "dynamicProperties": []};
@@ -129,10 +132,10 @@
 		}
 	}
 	
-	return new EntityCollection(this._ai, ret, this._filters.concat([filter]));
+	return new m.EntityCollection(this._ai, ret, this._filters.concat([filter]));
 };
 
-EntityCollection.prototype.filter_raw = function(callback, thisp)
+m.EntityCollection.prototype.filter_raw = function(callback, thisp)
 {
 	var ret = {};
 	for (var id in this._entities)
@@ -142,10 +145,10 @@
 		if (callback.call(thisp, val, id, this))
 			ret[id] = ent;
 	}
-	return new EntityCollection(this._ai, ret);
+	return new m.EntityCollection(this._ai, ret);
 };
 
-EntityCollection.prototype.forEach = function(callback)
+m.EntityCollection.prototype.forEach = function(callback)
 {
 	if (this._quickIter === true)
 	{
@@ -162,7 +165,7 @@
 	return this;
 };
 
-EntityCollection.prototype.filterNearest = function(targetPos, n)
+m.EntityCollection.prototype.filterNearest = function(targetPos, n)
 {
 	// Compute the distance of each entity
 	var data = []; // [ [id, ent, distance], ... ]
@@ -170,7 +173,7 @@
 	{
 		var ent = this._entities[id];
 		if (ent.position())
-			data.push([id, ent, SquareVectorDistance(targetPos, ent.position())]);
+			data.push([id, ent, m.SquareVectorDistance(targetPos, ent.position())]);
 	}
 	
 	// Sort by increasing distance
@@ -182,22 +185,22 @@
 	for each (var val in data.slice(0, n))
 		ret[val[0]] = val[1];
 	
-	return new EntityCollection(this._ai, ret);
+	return new m.EntityCollection(this._ai, ret);
 };
 
-EntityCollection.prototype.move = function(x, z, queued)
+m.EntityCollection.prototype.move = function(x, z, queued)
 {
 	queued = queued || false;
-	Engine.PostCommand({"type": "walk", "entities": this.toIdArray(), "x": x, "z": z, "queued": queued});
+	Engine.PostCommand(PlayerID,{"type": "walk", "entities": this.toIdArray(), "x": x, "z": z, "queued": queued});
 	return this;
 };
-EntityCollection.prototype.attackMove = function(x, z, queued)
+m.EntityCollection.prototype.attackMove = function(x, z, queued)
 {
 	queued = queued || false;
 	Engine.PostCommand({"type": "attack-walk", "entities": this.toIdArray(), "x": x, "z": z, "queued": queued});
 	return this;
 };
-EntityCollection.prototype.moveIndiv = function(x, z, queued)
+m.EntityCollection.prototype.moveIndiv = function(x, z, queued)
 {
 	queued = queued || false;
 	for (var id in this._entities)
@@ -206,16 +209,16 @@
 		// It disables JIT compiling of this loop. Don't remove it unless you are sure that the underlying issue has been resolved!
 		// TODO: Check this again after the SpiderMonkey upgrade.
 		try {} finally {}
-		Engine.PostCommand({"type": "walk", "entities": [this._entities[id].id()], "x": x, "z": z, "queued": queued});
+		Engine.PostCommand(PlayerID,{"type": "walk", "entities": [this._entities[id].id()], "x": x, "z": z, "queued": queued});
 	}
 	return this;
 };
-EntityCollection.prototype.destroy = function()
+m.EntityCollection.prototype.destroy = function()
 {
-	Engine.PostCommand({"type": "delete-entities", "entities": this.toIdArray()});
+	Engine.PostCommand(PlayerID,{"type": "delete-entities", "entities": this.toIdArray()});
 	return this;
 };
-EntityCollection.prototype.attack = function(unit)
+m.EntityCollection.prototype.attack = function(unit)
 {
 	var unitId;
 	if (typeof(unit) === "Entity")
@@ -226,18 +229,18 @@
 	{
 		unitId = unit;
 	}	
-	Engine.PostCommand({"type": "attack", "entities": this.toIdArray(), "target": unitId, "queued": false});
+	Engine.PostCommand(PlayerID,{"type": "attack", "entities": this.toIdArray(), "target": unitId, "queued": false});
 	return this;
 };
 // violent, aggressive, defensive, passive, standground
-EntityCollection.prototype.setStance = function(stance)
+m.EntityCollection.prototype.setStance = function(stance)
 {
-	Engine.PostCommand({"type": "stance", "entities": this.toIdArray(), "name" : stance, "queued": false});
+	Engine.PostCommand(PlayerID,{"type": "stance", "entities": this.toIdArray(), "name" : stance, "queued": false});
 	return this;
 };
 
 // Returns the average position of all units
-EntityCollection.prototype.getCentrePosition = function()
+m.EntityCollection.prototype.getCentrePosition = function()
 {
 	var sumPos = [0, 0];
 	var count = 0;
@@ -263,7 +266,7 @@
 // returns the average position from the sample first units.
 // This might be faster for huge collections, but there's
 // always a risk that it'll be unprecise.
-EntityCollection.prototype.getApproximatePosition = function(sample)
+m.EntityCollection.prototype.getApproximatePosition = function(sample)
 {
 	var sumPos = [0, 0];
 	var i = 0;
@@ -291,7 +294,7 @@
 
 
 // Removes an entity from the collection, returns true if the entity was a member, false otherwise
-EntityCollection.prototype.removeEnt = function(ent)
+m.EntityCollection.prototype.removeEnt = function(ent)
 {
 	if (this._entities[ent.id()])
 	{
@@ -310,7 +313,7 @@
 };
 
 // Adds an entity to the collection, returns true if the entity was not member, false otherwise
-EntityCollection.prototype.addEnt = function(ent)
+m.EntityCollection.prototype.addEnt = function(ent)
 {
 	if (this._entities[ent.id()])
 	{
@@ -333,7 +336,7 @@
 // Force can add a unit despite a freezing.
 // If an entitycollection is frozen, it will never automatically add a unit.
 // But can remove one.
-EntityCollection.prototype.updateEnt = function(ent, force)
+m.EntityCollection.prototype.updateEnt = function(ent, force)
 {	
 	var passesFilters = true;
 	for each (var filter in this._filters)
@@ -353,17 +356,17 @@
 	}
 };
 
-EntityCollection.prototype.registerUpdates = function(noPush)
+m.EntityCollection.prototype.registerUpdates = function(noPush)
 {
 	this._ai.registerUpdatingEntityCollection(this,noPush);
 };
 
-EntityCollection.prototype.unregister = function()
+m.EntityCollection.prototype.unregister = function()
 {
 	this._ai.removeUpdatingEntityCollection(this);
 };
 
-EntityCollection.prototype.dynamicProperties = function()
+m.EntityCollection.prototype.dynamicProperties = function()
 {
 	var ret = [];
 	for each (var filter in this._filters)
@@ -374,12 +377,16 @@
 	return ret;
 };
 
-EntityCollection.prototype.setUID = function(id)
+m.EntityCollection.prototype.setUID = function(id)
 {
 	this._UID = id;
 };
 
-EntityCollection.prototype.getUID = function()
+m.EntityCollection.prototype.getUID = function()
 {
 	return this._UID;
 };
+
+return m;
+
+}(API3);
Index: binaries/data/mods/public/simulation/ai/common-api-v3/utils.js
===================================================================
--- binaries/data/mods/public/simulation/ai/common-api-v3/utils.js	(Revision 14386)
+++ binaries/data/mods/public/simulation/ai/common-api-v3/utils.js	(Arbeitskopie)
@@ -1,11 +1,14 @@
-function VectorDistance(a, b)
+var API3 = function(m)
 {
+
+m.VectorDistance = function(a, b)
+{
 	var dx = a[0] - b[0];
 	var dz = a[1] - b[1];
 	return Math.sqrt(dx*dx + dz*dz);
 }
 
-function SquareVectorDistance(a, b)
+m.SquareVectorDistance = function(a, b)
 {
 	var dx = a[0] - b[0];
 	var dz = a[1] - b[1];
@@ -13,7 +16,7 @@
 }
 // A is the reference, B must be in "range" of A
 // this supposes the range is already squared
-function inRange(a, b, range)// checks for X distance
+m.inRange = function(a, b, range)// checks for X distance
 {
 	// will avoid unnecessary checking for position in some rare cases... I'm lazy
 	if (a === undefined || b === undefined || range === undefined)
@@ -24,26 +27,26 @@
 	return ((dx*dx + dz*dz ) < range);
 }
 // slower than SquareVectorDistance, faster than VectorDistance but not exactly accurate.
-function ManhattanDistance(a, b)
+m.ManhattanDistance = function(a, b)
 {
 	var dx = a[0] - b[0];
 	var dz = a[1] - b[1];
 	return Math.abs(dx) + Math.abs(dz);
 }
 
-function AssocArraytoArray(assocArray) {
+m.AssocArraytoArray = function(assocArray) {
 	var endArray = [];
 	for (var i in assocArray)
 		endArray.push(assocArray[i]);
 	return endArray;
 };
 
-function MemoizeInit(obj)
+m.MemoizeInit = function(obj)
 {
 	obj._memoizeCache = {};
 }
 
-function Memoize(funcname, func)
+m.Memoize = function(funcname, func)
 {
 	return function() {
 		var args = funcname + '|' + Array.prototype.join.call(arguments, '|');
@@ -56,7 +59,7 @@
 	};
 }
 
-function ShallowClone(obj)
+m.ShallowClone = function(obj)
 {
 	var ret = {};
 	for (var k in obj)
@@ -65,7 +68,7 @@
 }
 
 // Picks a random element from an array
-function PickRandom(list){
+m.PickRandom = function(list){
 	if (list.length === 0)
 	{
 		return undefined;
@@ -75,3 +78,7 @@
 		return list[Math.floor(Math.random()*list.length)];
 	}
 }
+
+return m;
+
+}(API3);
